<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_visit_reason".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeVisitReason".
 *
 * Columns in table "provider_practice_visit_reason" available as properties of the model,
 * followed by relations of table "provider_practice_visit_reason" available as properties of the model.
 *
 * @property integer $id
 * @property integer $visit_reason_id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property string $appointment_visit_duration
 *
 * @property VisitReason $visitReason
 */
abstract class BaseProviderPracticeVisitReason extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_visit_reason';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeVisitReason|ProviderPracticeVisitReasons', $n);
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('visit_reason_id, provider_id, practice_id', 'required'),
            array('visit_reason_id, provider_id, practice_id', 'numerical', 'integerOnly' => true),
            array('appointment_visit_duration', 'length', 'max' => 3),
            array('appointment_visit_duration', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, visit_reason_id, provider_id, practice_id, appointment_visit_duration', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'visitReason' => array(self::BELONGS_TO, 'VisitReason', 'visit_reason_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'visit_reason_id' => null,
            'provider_id' => null,
            'practice_id' => null,
            'appointment_visit_duration' => Yii::t('app', 'Appointment Visit Duration'),
            'visitReason' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('visit_reason_id', $this->visit_reason_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('appointment_visit_duration', $this->appointment_visit_duration, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
